package bytecode;

import static org.junit.Assert.*;

import java.io.File;
import java.lang.reflect.Method;
import java.net.URL;
import java.net.URLClassLoader;

import org.junit.BeforeClass;
import org.junit.Test;

import de.dhbwstuttgart.core.JavaTXCompiler;

public class BinaryTest {
	private static String path;
	private static File fileToTest;
	private static JavaTXCompiler compiler;
	private static ClassLoader loader;
	private static Class<?> classToTest;
	private static String pathToClassFile;
	private static Object instanceOfClass;
	
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
		path = System.getProperty("user.dir")+"/src/test/resources/bytecode/javFiles/BinaryInMeth.jav";
		fileToTest = new File(path);
		compiler = new JavaTXCompiler(fileToTest);
		pathToClassFile = System.getProperty("user.dir")+"/src/test/resources/testBytecode/generatedBC/";
		compiler.generateBytecode(pathToClassFile);
		loader = new URLClassLoader(new URL[] {new URL("file://"+pathToClassFile)});
		classToTest = loader.loadClass("BinaryInMeth");
		instanceOfClass = classToTest.getDeclaredConstructor().newInstance();
	}

	@Test
	public void test() throws Exception {
		Method m2 = classToTest.getDeclaredMethod("m2", Integer.class,Integer.class);
		Integer res = (Integer) m2.invoke(instanceOfClass, 2,3);
		assertEquals(new Integer(6), res);
	}
	
	@Test
	public void testM3() throws Exception {
		Method m3 = classToTest.getDeclaredMethod("m3", Integer.class);
		Integer res = (Integer) m3.invoke(instanceOfClass, 2);
		assertEquals(new Integer(4), res);
	}

}
